# -*- coding: utf-8 -*-
'''
National Instruments SystemLink Asset Performance Management Constants
'''
from __future__ import absolute_import, print_function, unicode_literals

from enum import IntEnum  # pylint: disable=import-error,3rd-party-module-not-gated

DATA_DIRECTORY = 'Data'
ASSETS_DIRECTORY = 'Assets'
USER_DEFINED_DIRECTORY = 'UserDefined'
USER_DEFINED_ENABLE_FILE = 'UserDefined.enable'

MODEL_NAME_KEY = 'ModelName'
MODEL_NUMBER_KEY = 'ModelNumber'
SERIAL_NUMBER_KEY = 'SerialNumber'
VENDOR_NAME_KEY = 'VendorName'
VENDOR_NUMBER_KEY = 'VendorNumber'
BUS_TYPE_KEY = 'BusType'

ASSET_TYPE_KEY = 'AssetType'

SELF_CALIBRATION_KEY = 'SelfCalibration'
EXTERNAL_CALIBRATION_KEY = 'ExternalCalibration'

ASSET_NAME_KEY = 'AssetName'
FIRMWARE_VERSION_KEY = 'FirmwareVersion'
HARDWRE_VERSION_KEY = 'HardwareVersion'
VISA_RESOURCE_NAME_KEY = 'VisaResourceName'
SUPPORTS_SELF_CALIBRATION_KEY = 'SupportsSelfCalibration'
SUPPORTS_EXTERNAL_CALIBRATION_KEY = 'SupportsExternalCalibration'
LOCATION_KEY = 'Location'

RESOURCE_URI_KEY = 'ResourceUri'
SLOT_NUMBER_KEY = 'SlotNumber'
PARENT_KEY = 'Parent'
STATE_KEY = 'State'
ASSET_PRESENCE_KEY = 'AssetPresence'

CALIBARTION_DATE_KEY = 'Date'
NEXT_RECOMMENDED_DATE_KEY = 'NextRecommendedDate'  # Not parsed
RECOMMENDED_INTERVAL_KEY = 'RecommendedInterval'
IS_LIMITED_KEY = 'IsLimited'
COMMENTS_KEY = 'Comments'
CHECKSUM_KEY = 'Checksum'
SUPPORTS_LIMITED_KEY = 'SupportsLimited'
SUPPORTS_WRITE_KEY = 'SupportsWrite'
OPERATOR_KEY = 'Operator'
CALIBRATION_TYPE = 'EntryType'
TEMPERATURE_SENSORS = 'TemperatureSensors'
SENSOR_NAME = 'Name'
SENSOR_READING = 'Reading'

DISPLAY_NAME_KEY = 'DisplayName'
USER_ID_KEY = 'UserId'


class PublishUserDefinedAssetsStatusCode(IntEnum):
    '''
    Enumeration defining possible status codes for the `publish_user_defined_assets` function
    '''
    INTERNAL_ERROR = -2
    HTTP_ERROR = -1
    SUCCESS = 0
    PARTIAL_SUCCESS = 1
    NO_JSON_FILES = 2
